<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>QLearner - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="EnumType.html">EnumType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="EnumType.html#getInterpolatedValue">getInterpolatedValue</a></li></ul></li><li><a href="ListType.html">ListType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="ListType.html#cost">cost</a></li></ul></li><li><a href="MidiType.html">MidiType</a><ul class='members'></ul></li><li><a href="ModalType.html">ModalType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="ModalType.html#getPi">getPi</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getNu">getNu</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getTau">getTau</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getRho">getRho</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getOp">getOp</a></li></ul></li><li><a href="NumericType.html">NumericType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="NumericType.html#getNormalized">getNormalized</a></li></ul></li><li><a href="QLearner.html">QLearner</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="QLearner.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#setParameters">setParameters</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#getQtable">getQtable</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#doAction">doAction</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#doNext">doNext</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#doPath">doPath</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#.newQLearner">newQLearner</a></li></ul></li><li><a href="RecordType.html">RecordType</a><ul class='members'></ul></li><li><a href="ScalarField.html">ScalarField</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="ScalarField.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#setParameters">setParameters</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#set">set</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#erase">erase</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#add">add</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#load">load</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#save">save</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getValues">getValues</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#has">has</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#get">get</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getValue">getValue</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getExtrapolations">getExtrapolations</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getBarycenter">getBarycenter</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getDiameter">getDiameter</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getDistance">getDistance</a></li></ul></li><li><a href="SetType.html">SetType</a><ul class='members'></ul></li><li><a href="StringType.html">StringType</a><ul class='members'></ul></li><li><a href="SvgType.html">SvgType</a><ul class='members'></ul></li><li><a href="Trajectory.html">Trajectory</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Trajectory.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#setParameters">setParameters</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#addPoint">addPoint</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#addRegion">addRegion</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#add">add</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#getNext">getNext</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#isDone">isDone</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#getPath">getPath</a></li></ul></li><li><a href="Type.html">Type</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Type.html#getValue">getValue</a></li><li data-type='method' style='display: none;'><a href="Type.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="Type.html#getValue">getValue</a></li><li data-type='method' style='display: none;'><a href="Type.html#getCheckMessage">getCheckMessage</a></li><li data-type='method' style='display: none;'><a href="Type.html#getDistance">getDistance</a></li><li data-type='method' style='display: none;'><a href="Type.html#getPath">getPath</a></li><li data-type='method' style='display: none;'><a href="Type.html#compare">compare</a></li><li data-type='method' style='display: none;'><a href="Type.html#getBound">getBound</a></li><li data-type='method' style='display: none;'><a href="Type.html#getBounds">getBounds</a></li><li data-type='method' style='display: none;'><a href="Type.html#.getType">getType</a></li><li data-type='method' style='display: none;'><a href="Type.html#.getTypeNames">getTypeNames</a></li><li data-type='method' style='display: none;'><a href="Type.html#.getTypeParameters">getTypeParameters</a></li><li data-type='method' style='display: none;'><a href="Type.html#.addType">addType</a></li></ul></li></ul><h3>Global</h3><ul><li><a href="global.html#json2midi">json2midi</a></li><li><a href="global.html#json2svg">json2svg</a></li><li><a href="global.html#midi2Jon">midi2Jon</a></li><li><a href="global.html#svg2json">svg2json</a></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">QLearner</h1>
    

    




<section>

<header>
    
        <h2>
        
            QLearner
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="QLearner"><span class="type-signature"></span>new QLearner<span class="signature">(parameters)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements a Q-learning reinforcement learning mechanism on a symboling space.</p>
<p><a name="parameters"></a></p>
<h2>QLearner parameters</h2>
<h3>General parameter</h3>
<ul>
<li><code>state_type: ...</code> The type element used to calculate the state distance, mandatory, default is &quot;value&quot;.</li>
<li><code>action_type: ...</code> The type element used to calculate the action distance, mandatory, default is &quot;value&quot;.</li>
<li><code>initial_state: ...</code> The initial current state, mandatory, default is &quot;empty&quot;.</li>
<li><code>initial_action: ...</code> The default and initial current state, mandatory, default is &quot;empty&quot;.</li>
<li><code>initial_time: ...</code> The initial discrete time step, default is 0.</li>
<li><code>gamma: ...</code> The Q-Learner application dependent discount factor, default is 0.5.</li>
<li><code>alpha: ...</code> The Q-Learner table learning rate, default is 0.1.</li>
<li><code>epsilon: ...</code> The threshold between to indistinguishable numerical value, default is <code>1e-3</code>.</li>
<li><code>K_max: ...</code> The maximal cardinal of the interpolation neighborhood, default is -1 (i.e., no bound).</li>
<li><code>d_max: ...</code> The maximal distance of a neighborhood, default is DBL_MAX (i.e., no bound).</li>
<li><code>bounds_count: ...</code> The maximal number of bounds to take into account for local neighborhood extrapolation, default is 0 (i.e., all bounds).</li>
</ul>
<p><a name="derivation"></a></p>
<h2>Implementation of a Q-Learner problem solver</h2>
<p>A Q-Learner problem solver</p>
<ul>
<li>
<p><a href="#.doAction"><code>doAction(action)</code></a>: The implementation of the environment feedback to a given action.</p>
</li>
<li>
<p><a href="#.getReward"><code>getReward(state, action)</code></a>: The calculation of the reward given the last action and updated state.</p>
<ul>
<li>Depending on the paradigm, the reward can be considered as given by the environment (external reward), or evaluated by the agent (internal reward).</li>
</ul>
</li>
<li>
<p>A typical implementation of a derived  type of name &quot;mytype&quot; is given by the following construct:</p>
</li>
</ul>
<pre class="prettyprint source"><code>#include &quot;QLearner.hpp&quot;
namespace symboling {
  class MyQLearner : public QLearner {
  public:
    MyQLearner() : QLearner(&quot;{type: &quot;MyType&quot;, ...}&quot;) {}

    // Considers the current state and action to evaluate the next state and reward accordingly.
    virtual void doAction(JSON action, unsigned int time, wjson::Value& state, double& reward) {
     ../..
    }
  };
}
</code></pre></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>
|

<span class="param-type">String</span>



            
            </td>

            

            

            <td class="description last"><p>The Qlearner parameters.</p></td>
        </tr>

    
    </tbody>
</table>



















        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="getParameters"><span class="type-signature"></span>getParameters<span class="signature">()</span><span class="type-signature"> &rarr; {JSON}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the QLearner parameters.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The QLearner parameters.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">JSON</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="setParameters"><span class="type-signature"></span>setParameters<span class="signature">(parameters)</span><span class="type-signature"> &rarr; {<a href="QLearner.html">QLearner</a>}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Modifies some QLearner parameters.</p>
<ul>
<li>All parameters but the <code>state_type</code> and <code>action_type</code> can be modified.</li>
<li>The Qtable is preserved when changing the parameters.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>



            
            </td>

            

            

            <td class="description last"><p>The QLearner parameters.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>This value allowing to chain methods.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type"><a href="QLearner.html">QLearner</a></span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="getQtable"><span class="type-signature"></span>getQtable<span class="signature">()</span><span class="type-signature"> &rarr; {<a href="ScalarField.html">ScalarField</a>}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the Qtable.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>A field of format, as proposed in <a href="ScalarField.html#getValues">ScalarField::getValues()</a>.:</p>
<pre class="prettyprint source"><code>[
  {
    input: {
      state: …      # The chosen state corresponding to this reward, of type `state_type`.
      action: …     # The chosen action for this reward, of type `action_type`.
 Additional items not taken into account for the field indexing:
      reward: …     # The reward resulting of the action and the related state, of type double.
      time: …       # The time step corresponding to this element of last modification of it,
                   of type unsigned integer, starting to 1 after the 1st action (time 0 is the initial state).
     }
     output:        # The reward resulting of the action and the related state, of type double.
  }
../..
]
</code></pre>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type"><a href="ScalarField.html">ScalarField</a></span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="doAction"><span class="type-signature"></span>doAction<span class="signature">(result)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Defines the interaction with the environment.</p>
<ul>
<li>This methods is to be overloaded to implements a given reinforcement learning environment.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>result</code></td>
            

            <td class="type">
            
                
<span class="param-type">Value</span>



            
            </td>

            

            

            <td class="description last"><p>The actual result with:</p>
<ul>
<li>Input:
<ul>
<li><code>action</code> The action to be output in the environment.</li>
<li><code>time</code>   The current time at the beginning of the action.</li>
</ul>
</li>
<li>Output&quot;
<ul>
<li><code>state</code>   The updated next state value resulting of the action.</li>
<li><code>reward</code>  The updated obtained reward resulting of the action, given the present state.</li>
</ul>
</li>
</ul></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id="doNext"><span class="type-signature"></span>doNext<span class="signature">()</span><span class="type-signature"> &rarr; {Value}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Performs the next action.</p>
<ul>
<li>A typical usage could be of the form</li>
</ul>
<pre class="prettyprint source"><code> // Memorizes the Q-Learner mechanism trajectory.
 std::Vector&lt;wjson::Value> path;
 for(unsigned int t = 0; t &lt; T; t++) {
   path.push_back(qlearning.doNext());
 }
</code></pre></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>A temporary data structure of the form of a Qtable element as detailed in <a href="#getQtable">getQtable()</a>.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Value</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="doPath"><span class="type-signature"></span>doPath<span class="signature">(max_path<span class="signature-attributes">opt</span>, max_reward<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {Value}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Performs a sequence of actions with this QLearner.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>max_path</code></td>
            

            <td class="type">
            
                
<span class="param-type">unit</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>0</code>
                
                </td>
            

            <td class="description last"><p>The maximal path length, default is 0 (no bound); it can also be sepcified as the &quot;max_path&quot; QLearner parameter.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>max_reward</code></td>
            

            <td class="type">
            
                
<span class="param-type">double</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>DBL_MAX</code>
                
                </td>
            

            <td class="description last"><p>The maximal reward value, after which the goal is considered as attained. Default is DBL_MAX; it can also be sepcified as the &quot;max_reward&quot; QLearner parameter.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>A temporary data structure of the form of a Qtable element's list, as detailed in <a href="#getQtable">getQtable()</a>.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Value</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id=".newQLearner"><span class="type-signature type-signature-static">(static) </span>newQLearner<span class="signature">(parameters, trajectory)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Creates a Qlearning module from a Trajectory specification.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>
|

<span class="param-type">String</span>



            
            </td>

            

            

            <td class="description last"><p>The Qlearner and related Trajectory parameters.</p>
<ul>
<li>The state corresponds to the (fully observable) trajectory current position.</li>
<li>The action corresponds to the (fully controalble) trajectory next position.</li>
<li>The reward corresponds to the complete trajectory subharmonic potential.</li>
<li>The QLearner <code>action_type</code> and <code>state_type</code> are equal to the trajectory data <code>type</code>, thus not be specified.</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>trajectory</code></td>
            

            <td class="type">
            
                
<span class="param-type"><a href="Trajectory.html">Trajectory</a></span>
|

<span class="param-type">JSON</span>
|

<span class="param-type">String</span>



            
            </td>

            

            

            <td class="description last"><p>The trajectory specification.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>A Qlearner with the objective to reach a trajectory goal. To be deleted after use.</p>
</div>



    



        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2024-03-05 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>